<?php
// +----------------------------------------------------------------------+
// | HIMMEL Core Library                             2004-07-23T22:08:58Z |
// |                                                        For PHP 4.3.8 |
// +----------------------------------------------------------------------+
// |                                              Original Version: 0.5.2 |
// +----------------------------------------------------------------------+
// | Distributed at http://www.arielworks.net/works/codeyard/himmel       |
// +----------------------------------------------------------------------+



class applyS3
{
    var $id;
    var $sdf_source;
    var $processor_root;
    var $xhtml_version;
    var $result_source;

    function applyS3($id, $sdf_source, $processor_root)
    {
        require_once(dirname(__FILE__) . "/lemmih.inc");

        $this->id             = $id;
        $this->sdf_source     = $sdf_source;
        $this->processor_root = $processor_root;

        /* Select XHTML version */
        $request_headers = apache_request_headers();
        $accept = explode(",", $request_headers["Accept"]);
        if (in_array("application/xhtml+xml", $accept)) {
            $this->xhtml_version = (double) 1.1;
        } else {
            $this->xhtml_version = (double) 1.0;
        }

        /* Translate into XHTML */
        $this->_translation();

    }

    function _translation()
    {
        /* Apply S3 */
        $param_S3 = array(array("http://www.arielworks.net/works/codeyard/sdf/s3", "processor_root", $this->processor_root),
                          array("http://www.arielworks.net/works/codeyard/sdf/s3", "id", $this->id));
        $result = $this->_smartXSLT($this->sdf_source, dirname(__FILE__)  . "/s3/interface.xsl", $param_S3);

        /* For old brosers */
        if ($this->xhtml_version == 1.0) {
            $result = $this->_smartXSLT($result, dirname(__FILE__) . "/11to10.xsl");
        }

        /* Strip space nodes and indent */
        $indent = domxml_open_mem($result, DOMXML_LOAD_DONT_KEEP_BLANKS);
        $result = $indent->dump_mem(FALSE, "UTF-8");
        $result = $this->_smartXSLT($result, dirname(__FILE__) . "/indent.xsl");

        /* Clean up namespace and set DOCTYPE */
        if ($this->xhtml_version == 1.0) {
            $result = $this->_smartXSLT($result, dirname(__FILE__) . "/valid10.xsl");
        } else {
        $result = $this->_smartXSLT($result, dirname(__FILE__) . "/valid11.xsl");
        }

        /* Hack for IE6 */
        if (preg_match("/MSIE 6.0/", $_SERVER["HTTP_USER_AGENT"])) {
            $result = preg_replace("/<\?xml.*?\?>(\n)?/", "", $result);
        }

        /* Hacks */
        $result = preg_replace("/<textarea([^>]*?)\/>/is", '<textarea$1></textarea>', $result);
        $result = preg_replace("/<script([^>]*?)\/>/is", '<script$1></script>', $result);
        $result = preg_replace("/(<[^>]*?[^ ])\/>/is", "$1 />", $result);

        $this->result_source = $result;
    }

    function _smartXSLT($xmls, $xsls, $param = array())
    {
        /* Load the sources */
        if (@is_file($xmls)) {
            $xml = domxml_open_file($xmls);
        } elseif(is_string($xmls)) {
            $xml = domxml_open_mem($xmls);
        } elseif(is_object($xmls)) {
            $xml = $xmls;
        }
        /*if (@is_file($xsls)) {
            $xsl = domxml_open_file($xsls);
        } elseif(is_string($xsls)) {
            $xsl = domxml_open_mem($xsls);
        } elseif(is_object($xsls)) {
            $xsl = $xsls;
        }*/

        /* XSLT */
        $proc = domxml_xslt_stylesheet_file($xsls);
        $param_php4 = array();
        foreach ($param as $param_item) {
            $param_php4[$param_item[1]] = $param_item[2];
        }
        $result = $proc->process($xml, $param_php4);
        return $result->dump_mem(FALSE, "UTF-8");
    }

    function saveResult()
    {
        return $this->result_source;
    }
}

class HIMMEL extends applyS3
{
    var $modified;

    function HIMMEL($id, $sdf_source, $processor_root)
    {
        $this->applyS3($id, $sdf_source, $processor_root);
        $this->_getModified();
    }

    function _getModified()
    {
        $dom_mod = domxml_open_mem($this->result_source);
        $xph_mod = xpath_new_context($dom_mod);
        $xph_mod->xpath_register_ns("xh", "http://www.w3.org/1999/xhtml");
        $node_mod = $xph_mod->xpath_eval("/xh:html/xh:head/xh:meta[./@name = 'WWWC']");
        $modified = $node_mod->nodeset[0]->get_attribute("content");
        $modified = str_replace("/", "-", substr($modified, 0, 10)) . "T" . substr($modified, -5, 5) . "Z";
        $modified = parse_w3cdtf($modified);
        $this->modified = $modified["timestamp"];
    }

    function process()
    {
        $this->sendHTTPHeaders();
        /* If-Modified-Since */
        $request_headers = apache_request_headers();
        $since = parse_http_date($request_headers["If-Modified-Since"]);
        if ($request_headers["If-Modified-Since"] && $since["timestamp"] >= $this->modified) {
            header("HTTP/1.1 304 Not Modified");
            return;
        }
        print $this->saveResult();
    }

    function sendHTTPHeaders()
    {
        if ($this->xhtml_version >= 1.1) {
            header("Content-Type: application/xhtml+xml; charset=UTF-8");
        } elseif ($this->xhtml_version == 1.0) {
            header("Content-Type: text/html; charset=UTF-8");
        }
        header("Last-Modified: " . gmdate("D, d M Y H:i:s", $this->modified) . " GMT");
        header("Content-Style-Type: text/css");
        header("Content-Script-Type: text/javascript");
    }
}
?>