<?php
// +----------------------------------------------------------------------+
// | MakeMap                                         2004-07-23T22:11:21Z |
// |                                                        For PHP 4.3.8 |
// +----------------------------------------------------------------------+
// |                                              Original Version: 0.5.2 |
// +----------------------------------------------------------------------+
// | Distributed at http://www.arielworks.net/works/codeyard/sdf/s3       |
// +----------------------------------------------------------------------+

require_once("../lemmih.inc");
require_once("../settings.php");

main();

function main()
{
    /* Make the directory tree */
    $tree = make_dirtree(PROCESSOR_ROOT, 2);

    /* Translate into XML SiteMap */
    $dd_sitemap = makeSiteMap($tree);
    $data_sitemap = $dd_sitemap->dump_mem(TRUE, "UTF-8");

    /* Save if changed */
    compSave($data_sitemap, "sitemap.xml");

    print "Complete";
}

function makeSiteMap($tree)
{

    $ns_sitemap = "http://www.arielworks.net/works/codeyard/sitemap";
    $ns_sdf     = "http://www.arielworks.net/works/codeyard/sdf";
    $ns_xh      = "http://www.w3.org/1999/xhtml";

    /* DomDocument for current branch */
    $dd_current = domxml_new_doc("1.0");
    $nd_page = $dd_current->create_element_ns($ns_sitemap, "page", "sm");
    $dd_current->append_child($nd_page);

    foreach ($tree as $item) {
        if ($item["name"] == TARGET_NAME) {
            $dd_tgt = domxml_open_file($item["path"], DOMXML_LOAD_DONT_KEEP_BLANKS);

            $xph_tgt = xpath_new_context($dd_tgt);
            $xph_tgt->xpath_register_ns("sdf", $ns_sdf);
            $xph_tgt->xpath_register_ns("xh", $ns_xh);

            /* Set page ID */
            $nd_id = $nd_page->append_child($dd_current->create_element_ns($ns_sitemap, "id", "sm"));
            if (substr($item["dir"], strlen($_SERVER["DOCUMENT_ROOT"])) == "") {
                $id = "/";
            } else {
                $id = substr($item["dir"], strlen($_SERVER["DOCUMENT_ROOT"]));
            }
            $nd_id->append_child($dd_current->create_text_node($id));

            /* Copy meta data */
            $nl_meta_contents = $xph_tgt->xpath_eval("/sdf:document/sdf:meta/node()");
            foreach ($nl_meta_contents->nodeset as $nd_meta_contents_item) {
                $nd_page->append_child($nd_meta_contents_item->clone_node(TRUE));
            }

            /* Copy description (first p element) */
            $nd_description = $dd_current->create_element_ns($ns_sitemap, "description", "sm");
            $nd_page->append_child($nd_description);
            $nl_description_contents = $xph_tgt->xpath_eval("/sdf:document/sdf:body/descendant::xh:p[text()][1]/node()");
            if ($nl_description_contents) {
                foreach ($nl_description_contents->nodeset as $nd_description_contents_item) {
                    $nd_description->append_child($nd_description_contents_item->clone_node(TRUE));
                }
            }
        } elseif ($item["type"] == "dir") {
            $dd_sub = makeSiteMap($item["sub"]);
            $xph_sub = xpath_new_context($dd_sub);
            $nl_sub_root = $xph_sub->xpath_eval("/*");
            if ($nl_sub_root->nodeset[0]->has_child_nodes()) {
                $nd_page->append_child($nl_sub_root->nodeset[0]->clone_node(TRUE));
            }
        }
    }

    /* Rename root element */
    if ($id == "/") {
        $nd_page->set_name("sitemap");
    }
    return $dd_current;
}

function compSave($data, $path)
{
    $now = @file_get_contents($path);
    if ($data != $now) {
        if ($handle = fopen($path, "w")) {
            flock($handle, LOCK_EX);
            fwrite($handle, $data);
            flock($handle, LOCK_UN);
            fclose($handle);
        }
    }
}

?>